/*
 * Listing #1 -- BIGLB.H (compile with medium model)
 */

#include <windows.h>

/* Note:  if you are using Borland C++ v3.1, you must alter their
   custcntl.h as follows, change:
      #if !defined(WINVER) || (WINVER < 0x030a)
   into:
      #if !defined(WINVER) || (WINVER < 0x030a) && !defined(STRICT)
 */
#include <custcntl.h>

#define LAST_LB_MSG (WM_USER+35)


/*
 * Data structure used to access data
 * in the style dialog box function.
 *
 * this definition was apparently not included
 * in CUSTCNTL.H
 */

typedef struct {
   GLOBALHANDLE hCtlStyle;
   LPFNSTRTOID  lpfnStrToId;
   LPFNIDTOSTR  lpfnIdToStr;
} CTLSTYLEDLG, FAR *LPCTLSTYLEDLG,
               NEAR *NPCTLSTYLEDLG;


#include <ctype.h>
#include <string.h>

/* memory management constants */
/* these values allow 1 meg of string space */
#define MAXPAGES 128
#define PAGESIZE 8192L

/* extra window byte offsets */

#define GWL_OLDPROC 0
#define GWL_PAGETABLE 4
#define GWL_CURRENT_PAGE 8
#define GWL_CURRENT_OFFSET 10
#define EXTRA_WND_BYTES 12

/* style dialog ID's */

#define ID_IDNAME  100
#define ID_NOTIFY  101
#define ID_SORT    102
#define ID_REDRAW  103
#define ID_LBTS    104
#define ID_INTEG   105
#define ID_MULTIC  106
#define ID_KEYB    107
#define ID_LBSB    108

#define ID_ATTS    109
#define ID_GROUP   110
#define ID_VIS     111
#define ID_DISA    112
#define ID_BORDER  113

#define ID_VERTSB  114
#define ID_HORZSB  115

/* string table ID's */

#define BIGLB_STYLE_DLG   0
#define IDS_CTL_PROP      1
#define IDS_CONTROL_NAME  2
#define IDS_SUBCLASS      3

#define IDS_NOTIFY       16
#define IDS_SORT         17
#define IDS_REDRAW       18
#define IDS_LBTS         19
#define IDS_INTEG        20
#define IDS_MULTIC       21
#define IDS_KEYB         22
#define IDS_LBSB         23
#define IDS_STAND        24

#define BIGLB_DEFAULT_STYLE\
 (LBS_STANDARD|WS_CHILD|WS_TABSTOP)

extern HINSTANCE ModuleInstance;

/* forward function delarations... */
LRESULT CALLBACK _export BigLBWndFn(HWND hWnd,
                                    UINT msg,
                                    WPARAM wParam,
                                    LPARAM lParam);
LRESULT CALLBACK _export BigLB_SubProc(HWND hWnd,
                                      UINT msg,
                                      WPARAM wParam,
                                      LPARAM lParam);
BOOL CALLBACK _export BigLBDlgFn(HWND hDlg,
                                 UINT msg,
                                 WPARAM wParam,
                                 LPARAM lParam);
LPSTR dll_malloc(HWND hWnd,DWORD len);
void dll_freeall(HWND hWnd);

