/*
 * Demonstration of DOS "append" bug
 */

#ifndef __TURBOC__
#error This program needs Turbo-C!
#endif

#include <stdio.h>
#include <process.h>
#include <io.h>
#include <dir.h>
#include <dos.h>

#define CARRY   (_FLAGS & 1)

static char near CurAppendPath[150] = {0};
static char near Work[150]          = {0};
static char near DangerDanger[100]  = "XXXXXXXX.XXX";
static char near RestoreAppend      = 0;

static void fatal(char *msg)
        {
        if (RestoreAppend)
                system(CurAppendPath);
        printf("*** ERROR *** [%s]\n", msg);
        exit(1);
        }

void main(void)
        {
        char far *AppendPath;
        char far *p;
        int       handle;

        printf("+---------------------------------------+\n"
               "| The case of the deadly APPEND command |\n"
               "+---------------------------------------+\n"
               "| Tony Ingenoso, 1992                   |\n"
               "+---------------------------------------+\n");

        /*-----------------------------------------------
                      Check for DOS 4.0+
        -----------------------------------------------*/
        _AX = 0x3000;
        geninterrupt(0x21);
        if (_AL < 4)
                fatal("I Need DOS 4.0 or better for this demo.");

        /*-----------------------------------------------
                      Check for APPEND
        -----------------------------------------------*/
        _AX = 0xB700;
        geninterrupt(0x2F);
        if (_AL != 0xFF)
                fatal("APPEND isn't loaded.");

        /*-----------------------------------------------
               Get APPEND's current path
        -------------------------------------------------
        Int 2F fn B7 subfn 04 returns pointer in ES:DI
        -----------------------------------------------*/
        _AX = 0xB704;
        geninterrupt(0x2F);
        AppendPath = MK_FP(_ES,_DI);

        /*-----------------------------------------------
        Save APPEND's current path in a form that we can
        restore with a call to system() later.
        -----------------------------------------------*/
        for (p = Work; *AppendPath;)
                *p++ = *AppendPath++;
        *p = '\0';
        sprintf(CurAppendPath, "APPEND %s", Work);

        /*-----------------------------------------------
          Make a temporary directory with a file named
          XXXXXXXX.XXX in it.
        -----------------------------------------------*/
        if (mkdir("__TEMP.DIR"))
                fatal("I couldn't make temp directory");

        if ((handle = _creat("__TEMP.DIR\\XXXXXXXX.XXX", 0)) == -1)
                fatal("I couldn't create temp file");

        _close(handle);

        /*-----------------------------------------------
          Aim APPEND at the temp directory we just made.
        -----------------------------------------------*/
        if (system("APPEND __TEMP.DIR"))
                fatal("Couldn't exec APPEND");
        RestoreAppend = 1;

        /*-----------------------------------------------
          At this point we've saved the old APPEND path
          and have set a new one to a temp directory we
          just created.  We're now in position to try a
          file open operation on the temp file in the
          temp directory that only APPEND knows about.
          At this point we are going to 'arm' APPEND to
          *OVERWRITE* the filename string on the NEXT
          Int 21 call.
        -----------------------------------------------*/
        printf("The initial name string = [%s]\n", DangerDanger);

        _AX = 0xB711;        /* Arm the APPEND weapon            */
        geninterrupt(0x2F);  /* This is it...it's set to go off! */

        _BX = _psp;          /* An activating TSR would do       */
        _AX = 0x5000;        /* something like this...           */
        geninterrupt(0x21);

#pragma warn -apt
        _DX = (void near *)(void far *)&DangerDanger[0];
#pragma warn .apt
        _CX = 0;
        _AX = 0x3D00;        /* Open the file                    */
        geninterrupt(0x21);  /* BANG!, This should trigger it.   */
        if (CARRY)
                fatal("Couldn't open file");
        _close(_AX);

        printf("The overwritten string  = [%s]\n", DangerDanger);

        /*-----------------------------------------------
            Cleanup and restore original APPEND path.
        -----------------------------------------------*/
        unlink("__TEMP.DIR\\XXXXXXXX.XXX");
        rmdir("__TEMP.DIR");
        system(CurAppendPath);
        }
