/*                   Listing 1
                  Test program for
         Windows vertical button class for C++
    Copyright (c) 1992 Hills Object Technology, Inc.
                 All Rights Reserved
Borland C++ 3.1 compile:
            bcc -WS vbuttest
*/
#include <windows.h>
#include "vbutclas.h"
#include "property.cpp"
#include "vbutton.cpp"

extern "C" {
LRESULT WINAPI _export WndProc(HWND,UINT,UINT,LONG);
    };

int PASCAL WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPSTR lpszCmdLine, int nCmdShow)
{
    static char szAppName[] = "Vertical Button";
    HWND hwnd;
    MSG msg;
    WNDCLASS wndclass;

    if (!hPrevInstance) {
        wndclass.style = CS_HREDRAW | CS_VREDRAW;
        wndclass.lpfnWndProc = WndProc;
        wndclass.cbClsExtra = 0;
        wndclass.hInstance = hInstance;
        wndclass.hIcon = LoadIcon(NULL,
                                  IDI_APPLICATION);
        wndclass.hCursor = LoadCursor(NULL,
                                      IDC_ARROW);
        wndclass.hbrBackground = (HBRUSH)
                        GetStockObject(WHITE_BRUSH);
        wndclass.lpszMenuName = NULL;
        wndclass.lpszClassName = szAppName;

        RegisterClass(&wndclass);
    }
    hwnd = CreateWindow(szAppName,
                    "Vertical Button Demo",
                    WS_OVERLAPPEDWINDOW,
                    CW_USEDEFAULT,
                    CW_USEDEFAULT,
                    CW_USEDEFAULT,
                    CW_USEDEFAULT,
                    NULL,
                    NULL,
                    hInstance,
                    NULL);
    ShowWindow(hwnd,nCmdShow);
    UpdateWindow(hwnd);

    while(GetMessage((LPMSG)&msg,NULL,0,0)) {
        if (!IsWindow(hwnd) ||
            (!IsDialogMessage(hwnd,&msg)))  {
            TranslateMessage(&msg);
            DispatchMessage(&msg);
        }
    }

    return msg.wParam;
}

extern "C" {
LRESULT WINAPI _export WndProc(HWND hwnd, UINT message,
                        WPARAM wParam, LPARAM lParam) {

    static VButton *vertptr1;
    static VButton *vertptr2;
               int reply;

    switch(message) {

        case WM_CREATE:

            vertptr1 = cc_VertButton(hwnd,

                ((LPCREATESTRUCT)lParam)->hInstance,
                102,"&Vertical 1",232,20);

            vertptr2 = cc_VertButton(hwnd,

                ((LPCREATESTRUCT)lParam)->hInstance,
                103,"V&ertical 2",132,20);

            vertptr1->Focus(); // Start Tab sequence
            return TRUE;

        case WM_COMMAND:
            switch (wParam) {

                case 102:
    MessageBox
               (hwnd, (LPSTR)vertptr1->GetLabel(),
               (LPSTR)"Button Activated.", MB_OK);
                    vertptr1->Focus();
                    return TRUE;

                case 103:

    reply = MessageBox(hwnd,
    (LPSTR)"Button Activated.\nYes changes button 1",
               (LPSTR)vertptr2->GetLabel(),MB_YESNO);
       if (reply == IDYES)
          vertptr1->SetLabel("&New Vertical 1",TRUE);

                    vertptr2->Focus();
                    return TRUE;
            }
    }
    return DefWindowProc(hwnd,message,wParam,lParam);
}
};
